package Klava;

public class AcceptConnNodeCoordinator extends NodeCoordinator {
  protected boolean one_time;

  public AcceptConnNodeCoordinator() {
    this(false);
  }

  public AcceptConnNodeCoordinator(boolean one_time) {
    this.one_time = one_time;
  }

  public void execute() throws Klava.KlavaException {
    PhysicalLocality loc;
    while (true) {
      loc = new PhysicalLocality();
      acceptconn(loc);
      Print("New direct connection: " + loc);
      if (one_time)
        break;
    }
  }
}