package Klava ;

// Customized Integer

public class KInteger implements TupleItem {

  public Integer integer ;

  public KInteger() { integer = null ; }
  public KInteger( int i ) { integer = new Integer(i) ; }
  public KInteger( Integer i ) { integer = new Integer(i.intValue()) ; }
  public KInteger( KInteger i ) { 
      integer = ( i.isFormal () ?
                  null :
                  new Integer(i.intValue()) ) ; 
  }

  public String toString() { 
    if ( integer != null )
      return integer.toString() ;
    else 
      return "!KInteger" ;
  }

  public int intValue() { return ( integer != null ? integer.intValue() :
                                     0 ) ; }

  // TupleItem methods
  public boolean isFormal() { return (integer==null) ; }
  
  public void setFormal() { integer = null ; }

  public void setValue( Object o ) {
    try {
      if ( o != null && ((KInteger)o).integer != null )
        integer = new Integer( ((KInteger)o).integer.intValue() ) ;
    } catch ( ClassCastException e ) {
      System.err.println( "KInteger : " + e ) ;
    }
  }

  public boolean equals( Object o ) {
    return integer.equals( ((KInteger)o).integer ) ;
  }

  public Object duplicate() { return new KInteger( this ) ; }
}
