package Klava;

import momi.*;

public class KMixin extends MoMiTupleItem {
    public KMixin(MoMiType type) {
        super(type);
    }

    public KMixin(MoMiType type, Mixin mixin) {
        super(type, mixin);
    }

    public final MoMiObject new_instance() {
        return ((Mixin)value).new_instance();
    }

    public Object duplicate() {
        return new KMixin(type, (Mixin)value);
    }

    public final Mixin getMixin() {
        return (Mixin) getValue();
    }

    public static MoMiClass apply(Mixin m, MoMiClass c)
            throws NoSuchMethodException {
        return Mixin.apply(m, c);
    }

    public static MoMiClass apply(KMixin m, KMoMiClass c)
            throws NoSuchMethodException {
        return Mixin.apply(m.getMixin(), c.getMoMiClass());
    }

    public static MoMiClass apply(Mixin m, KMoMiClass c)
            throws NoSuchMethodException {
        return Mixin.apply(m, c.getMoMiClass());
    }

    public static MoMiClass apply(KMixin m, MoMiClass c)
            throws NoSuchMethodException {
        return Mixin.apply(m.getMixin(), c);
    }
}