package Klava;

/**
 * a nodecoordinator that does nothing but executing login
 * to a specific server
 */

public class LoginNodeCoordinator extends NodeCoordinator {
  protected Locality server;

  public LoginNodeCoordinator(Locality server) {
    this.server = server;
  }

  public void execute() throws Klava.KlavaException {
    Print("Login to " + server);
    if (login( server ))
      login_success(server);
    else
      login_failed(server);
  }

  public void login_success(Locality loc) {
    Print("Login succedeed to " + loc);
  }

  public void login_failed(Locality loc) {
    Print("Login failed to " + loc);
  }
}