package Klava ;

import java.awt.* ;
import java.io.* ;

public class NodeList extends Node implements withPanel {

  protected boolean visible = true ;
  protected Panel listPanel ;

  public NodeList( String Name, String Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
  }

  public NodeList( String Name, String Here, String NetHostName, Integer NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort ) ;
  }

  public NodeList( String Name, PhysicalLocality Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
  }

  protected TupleSpace newTupleSpace() {
    TupleSpaceList TSS = new TupleSpaceList( name ) ;
    listPanel = TSS.getPanel() ;
    return TSS ;
  }

  public void setVisible( boolean vis ) { visible = vis ; }

  // withPanel interface
  public Panel getPanel() { return listPanel ; }

  public static void main( String args[] ) throws IOException, KlavaException {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeList n = new NodeList( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    KlavaFrame frame = new KlavaFrame( "testNodeList", n ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;
    frame.pack() ;
    frame.show() ;
    n.start() ;
  }
}
