package Klava;

/**
 * store queues (tuple spaces) for each protocol
 */

import java.util.Hashtable;

public class ProtocolTable {
  // key: protocol name, value: tuple space
  protected Hashtable prot_table = new Hashtable();

  synchronized TupleSpace handle_protocol(String s) {
    return (TupleSpace) prot_table.get(s);
  }

  // if it does not exist, create it
  synchronized TupleSpace get_protocol_ts(String s) {
    TupleSpace ts = (TupleSpace) prot_table.get(s);
    if (ts == null) {
      ts = new TupleSpace();
      prot_table.put(s, ts);
    }

    return ts;
  }
}