package Klava;

/**
 * Specialization that prints on System.out
 */

public class SystemOutMessagePrinter extends MessagePrinter {
  public SystemOutMessagePrinter(String name, MessagePrinter printer) {
    super(name, printer);
  }

  public void Print(String s) {
    super.Print(s);
    System.out.println("(" + name + ")" + s);
  }
}