
//Title:        Klava
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description


package Klava;

import java.util.Enumeration ;
import java.awt.Component ;

public class TupleSpaceKeyboard extends TupleSpace
    implements java.io.Serializable, KlavaMonitor {
  protected KlavaMonitorable monitorable ;

  public TupleSpaceKeyboard( KlavaMonitorable km ) {
    monitorable = km ;
    monitorable.addMonitor( this ) ;
  }

  // KlavaMonitor interface
  public Component getArea() { return null ; } // mhh...
  public void setVisible( boolean b ) {} // mhh...
  public void addElem( Object o ) {
    try {
      outString( o.toString() ) ;
      System.out.println( "TS : " + this ) ;
    } catch ( KlavaTupleParsingException e ) {
      System.err.println( e ) ;
    }
  }
  public void removeElem( Object o ) {}
  public void removeAll() {} 
  public Enumeration getElements() { return null ; }
  public void setMonitor( KlavaMonitor m ) {} // mhh...
  public boolean isVisible() { return true ; } // mhh...

  public static void main(String[] args) {
    String label = "" ;
    if ( args.length == 1 )
      label = args[0] ;
    MonitorableKeyboardPanel monitorableKeyboard = new MonitorableKeyboardPanel( label ) ;
    KlavaFrame kf = new KlavaFrame( "TupleSpaceKeyboard", monitorableKeyboard ) ;
    TupleSpaceKeyboard tupleSpaceKeyboard =
      new TupleSpaceKeyboard( monitorableKeyboard );
    kf.pack() ;
    kf.show() ;
    tupleSpaceKeyboard.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
}