/**
 * Base class for a generic NodeCoordinator that waits for unsubscriptions
 */

package Klava;

public class UnregisterNodeCoordinator extends NodeCoordinator {
  public void execute() throws Klava.KlavaException {
    LogicalLocality log_loc;
    while (true) {
      log_loc = new LogicalLocality();
      unregister(log_loc);
      unregistration_tookplace(log_loc);
    }
  }

  protected void unregistration_tookplace(LogicalLocality log_loc) {
    Print("Unregistered " + log_loc);
  }
}