package Klava.debug ;

public class CallDepthCondition implements Breakpoint.Condition {

  protected int maxDepth ;

  public CallDepthCondition( int maxDepth ) {
    this.maxDepth = maxDepth ;
  }

  public boolean isSatisfiedBy( KlavaAgent a ) throws DebugException {
    return ( a.getCurrentProcess().getCallDepth() <= maxDepth ) ;
  }

}