
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description


package klavatest;

import Klava.*;
import java.io.* ;

public class testNode extends KlavaProcess {

  public testNode() {
  }

  public void execute() throws KlavaException {
    try {
      Thread.sleep( 3000 ) ;
    } catch ( InterruptedException e ) {}
    for ( int i = 1 ; i < 30 ; ++i ) {
      KString s = new KString() ;
      out( new KInteger(10), new KInteger(20), self ) ;
      out( new KBoolean(true), self ) ;
      out( new KString("hi"), self ) ;
      in( s, self ) ;
    }
    System.out.println( "DONE ! :-)" ) ;
  }

  public static void main( String args[] ) throws Exception {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    Node n = new Node( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;
    n.addToEnv( "loc1", "ploc1" ) ;
    n.addToEnv( "loc2", "ploc2" ) ;
    n.start() ;
    n.addProcess( new testNode() ) ;
  }
}
