package klavatest;

/**
 * Title: testProcessInNode
 * Description: test for a process started before a node is connected;
 * the process is started the same but remote operations block it, until
 * connection
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import Klava.*;

class testPN extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("*** Process already started ***");
    in( new KString(), new PhysicalLocality ("test2"));
  }
}

public class testProcessInNode {

  public static void main(String[] args) throws Exception {
    Node node = new Node("test", "test", "localhost", 9999);
    Node node2 = new Node("test2", "test2", "localhost", 9999);

    testPN P = new testPN();
    node.addProcess (P);

    node2.start ();
    node2.out(new Tuple(new KString("hi")), new LogicalLocality ("self"));

    Thread.sleep (3000);
    node.start ();
  }
}