/**
 * LocalInFailure
 *
 * retrieves a tuple crypted with a different key, using an in
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class LocalInFailureConcProc1 extends KlavaProcessx {

    public LocalInFailureConcProc1() throws Exception {
	//super (new KStoreFileAccess("LocalInFailure1.answers"));
	super (new KStoreDialogAccess());
    }

      public void execute() throws KlavaException {
	//while (true) {
	    try {
		eval( new LocalInFailureConcProc13( myKeyStore ) );
		eval( new LocalInFailureConcProc12( myKeyStore ) ) ;
		eval( new LocalInFailureConcProc11( myKeyStore ) ) ;
	    } catch (Exception e) {
		e.printStackTrace() ;
	    }
	//}
    }
}

class LocalInFailureConcProc11 extends KlavaProcessx {

    public LocalInFailureConcProc11(KStore myKeyStore) throws Exception {
	this.myKeyStore=myKeyStore ;

    }

    public void execute() throws KlavaException {
	try {
	    setEncKey("Chiave per cifrare la tupla1");

	    Tuplex tx1 = new Tuplex() ;
	    tx1.add(new KString("lorenzo1")) ;
	    KString s = new KString("usata chiave1") ;
	    tx1.add(new KCipher(s)) ;
	    tx1.encode();
	    out(tx1,self) ;
	    //unsetEncKey();
	} catch (Exception e1) {
	    e1.printStackTrace ();
	}
    }
}

class LocalInFailureConcProc12 extends KlavaProcessx {

    public LocalInFailureConcProc12(KStore myKeyStore) throws Exception {
	this.myKeyStore=myKeyStore ;

    }

    public void execute() throws KlavaException {
	try {
	    //setEncKey("Chiave per cifrare la tupla2");
	    Tuplex tx3 = new Tuplex() ;
	    tx3.add(new KString("lorenzo2")) ;
	    KString s3 = new KString("usata chiave1") ;
	    tx3.add(new KCipher(s3)) ;
	    tx3.encode();
	    out(tx3,self) ;
	    //unsetEncKey();
	} catch (Exception e1) {
	    e1.printStackTrace ();
	}
    }
}

class LocalInFailureConcProc13 extends KlavaProcessx {

    public LocalInFailureConcProc13(KStore myKeyStore) throws Exception {
	this.myKeyStore=myKeyStore ;
    }

    public void execute() throws KlavaException {
	try {
	    //setEncKey("Chiave per cifrare la tupla3");
	    Tuplex tx4 = new Tuplex() ;
	    tx4.add(new KString("lorenzo3")) ;
	    KString s4 = new KString("usata chiave1") ;
	    tx4.add(new KCipher(s4)) ;
	    tx4.encode();
	    out(tx4,self) ;
	    //unsetEncKey();
	} catch (Exception e1) {
	    e1.printStackTrace ();
	}
	try {
	    //setEncKey("Chiave per cifrare la tupla4");
	    Tuplex tx2 = new Tuplex() ;
	    tx2.add(new KString("bettini")) ;
	    KString s2 = new KString("usata chiave2") ;
	    tx2.add(new KCipher(s2)) ;
	    tx2.encode();
	    out(tx2,self) ;

	} catch (Exception e2) {
	    e2.printStackTrace ();
	}
    }
}

class LocalInFailureConcProc2 extends KlavaProcessx {

    public LocalInFailureConcProc2() throws Exception {
	//super (new KStoreFileAccess("LocalInFailure2.answers"));
	super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
	//while (true) {
	    try {
		eval( new LocalInFailureConcProc21( myKeyStore ) );
		eval( new LocalInFailureConcProc22( myKeyStore ) ) ;
	    } catch (Exception e) {
		e.printStackTrace() ;
	    }
	//}
    }
}

class LocalInFailureConcProc21 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("self");

    public LocalInFailureConcProc21(KStore myKeyStore) throws Exception {
	//super (new KStoreDialogAccess());
	this.myKeyStore=myKeyStore ;
    }

    public void execute() throws KlavaException {
        try {
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
            KCipher k = new KCipher( fString1 ) ;
            txf1.add( k ) ;

	    in(txf1, dati) ;

	    out(s1,self);
            out(fString1,self);
	} catch (Exception e) {
            e.printStackTrace ();
	}
	//out("a",self);
    }
}

class LocalInFailureConcProc22 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("self");

    public LocalInFailureConcProc22(KStore myKeyStore) throws Exception {
	//super (new KStoreDialogAccess());
	this.myKeyStore=myKeyStore ;
    }

    public void execute() throws KlavaException {
        try {
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
            KCipher k = new KCipher( fString1 ) ;
            txf1.add( k ) ;

	    in(txf1, dati) ;

	    out(s1,self);
            out(fString1,self);
	} catch (Exception e) {
            e.printStackTrace ();
	}
	//out("b",self);
    }
}

public class LocalInFailureConcorr {
    static public void main  (String args[]) throws Exception {
        Node Node1 = new NodeG ("node1", 9998, "localhost", 9999 );
	//Node1.addToEnv("dati", "loc1");
        Node1.setLocalMatcher (new KCipherLocalMatcher ());
        Node1.setLocalTupleSpaceMatcher
            (new KCipherLocalTupleSpaceMatcher ());
	Node1.start();
	Node1.addProcess (new LocalInFailureConcProc1());
	Node1.addProcess (new LocalInFailureConcProc2());
    }
}
