/**
 * LocalTuple
 * Try to retrieve a tuplex with a tuple and to decrypt
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class LocalTupleProc1 extends KlavaProcessx {

    public LocalTupleProc1() throws Exception {
	super (new KStoreFileAccess("Trystore1.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
	    setEncKey("1");
            
            Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("lorenzo1")) ;
            KString s = new KString("usata chiave1") ;
            tx1.add(new KCipher(s)) ;
	    tx1.encode();
            out(tx1,self) ;
	    
	} catch (Exception e1) {
            e1.printStackTrace ();
        }
    }
}

class LocalTupleProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("self");

    public LocalTupleProc2() throws Exception {
	super (new KStoreFileAccess("Trystore2.answers"));
	//super (new KStoreDialogAccess());
    }
    
    public void execute() throws KlavaException {
        try {
	    Tuple txf1 = new Tuple() ;
	    KString s1 = new KString() ;
	    txf1.add( s1 ) ;
	    KString fString1 = new KString() ;
	    KCipher k = new KCipher( fString1 ) ;
            txf1.add( k ) ;
	    
	    read(txf1, dati) ;
	    
	    Tuplex t = new Tuplex( txf1 ) ;
	    //t.matchTuplex((KlavaProcessx) Thread.currentThread () ) ;
            t.decode ();
	    out(s1,self);
            out(fString1,self);
	} catch (Exception e) {
            e.printStackTrace ();
        }
    }
}

public class LocalTuple {
    static public void main  (String args[]) throws Exception {
        Node Node1 = new NodeG ("node1", "loc1", "localhost", 9999 );
        Node1.setLocalMatcher (new KCipherLocalMatcher ());
        Node1.setLocalTupleSpaceMatcher
            (new KCipherLocalTupleSpaceMatcher ());
	Node1.start();
	Node1.addProcess (new LocalTupleProc1());
	Node1.addProcess (new LocalTupleProc2());
    }
}
