package Klava;

import java.awt.*;
import java.awt.event.*;

public class ClosableFrame extends Frame
{
  public ClosableFrame(String title)
  {
    super (title);
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        this_windowClosing(e);
      }
    });
  }

  void this_windowClosing(WindowEvent e)
  {
    close_this_window ();
  }

  // to be redefined
  protected void close_this_window()
  {
    dispose ();
  }
}

