/**
 * Base class for a generic NodeCoordinator that waits for disconnections
 */

package Klava;

public class DisconnectedNodeCoordinator extends NodeCoordinator {
  public void execute() throws Klava.KlavaException {
    PhysicalLocality loc;
    while (true) {
      loc = new PhysicalLocality();
      disconnected(loc);
      disconnection_tookplace(loc);
    }
  }

  protected void disconnection_tookplace(PhysicalLocality loc) {
    Print("Disconnection: " + loc);
  }
}