package Klava ;

public class InfoMessages implements KlavaMonitorable {

  protected KlavaMonitorable monitorable ;

  public InfoMessages() { this( null ) ; }
  public InfoMessages( KlavaMonitorable m ) {
      if ( m == null )
          monitorable = newMonitorable() ;
      else
          monitorable = m ;
  }

  public KlavaMonitorable newMonitorable()  // Factory Method
    { return new KlavaMonitorableDefault() ; }

  // KlavaMonitorable interface
  public void addMonitor( KlavaMonitor m )
    {
        monitorable.addMonitor( m ) ;
        // updateMonitor( m ) ;  Previous messages are lost...
    }
  public void removeMonitor( KlavaMonitor m )
    { monitorable.removeMonitor( m ) ; }
  public void notifyAddElement( Object o )
    { monitorable.notifyAddElement( o ) ; }
  public void notifyRemoveElement( Object o )
    { monitorable.notifyRemoveElement( o ) ; }

  public void notifyRemoveAll() {
    monitorable.notifyRemoveAll();
  }

    public void PrintMessage( String s ) {
        notifyAddElement( s ) ;
    }
}
