
//Title:        Klava
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description

package Klava;

import java.awt.*;
import java.util.Enumeration ;
import java.awt.event.*;

public class KlavaMonitorTextAreaPanel extends Panel implements KlavaMonitor
{
  BorderLayout borderLayout1 = new BorderLayout();
  TextArea textArea = new TextArea();
  Panel button_panel = new Panel();
  Button clear_button = new Button();


  public KlavaMonitorTextAreaPanel() {
    try  {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  // KlavaMonitor interface
  public Component getArea() { return this ; }
  // public void setVisible( boolean b ) ; implemented by Base class
  public void addElem( Object o ) { textArea.append( o.toString() ) ; }
  public void removeElem( Object o ) {
    // cannot delete from a text area, sorry ;-)
  }
  public Enumeration getElements() {
    return null ; // at least for now ;-)
  }
  public void setMonitor( KlavaMonitor m ) {
    add( m.getArea() ) ;
  }
  // public boolean isVisible() ; implemented by Base class

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    clear_button.setLabel("clear");
    clear_button.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        clear_button_actionPerformed(e);
      }
    });
    this.add(textArea, BorderLayout.CENTER);
    this.add(button_panel, BorderLayout.EAST);
    button_panel.add(clear_button, null);
  }

  void clear_button_actionPerformed(ActionEvent e)
  {
    textArea.setText ("");
  }
}

 
