package Klava;

/**
 * Factory for MessagePrinter
 */

public abstract class MessagePrinterFactory {
  protected String prefix = "";
  protected String suffix = "";

  public void setPrefix(String prefix) {
    this.prefix = prefix;
  }

  public void setSuffix(String suffix) {
    this.suffix = suffix;
  }

  public abstract MessagePrinter
    createMessagePrinter(String name, MessagePrinter p);
}