/**
 * specialization of NodeCoordinator that waits for disconnections
 * for Net
 */

package Klava;

public class NetDisconnectedNodeCoordinator
    extends DisconnectedNodeCoordinator {
  protected Net net;

  public NetDisconnectedNodeCoordinator(Net net) {
    this.net = net;
  }

  protected void disconnection_tookplace(PhysicalLocality loc) {
    super.disconnection_tookplace(loc);
    net.PrintRemovedNode(loc);
  }
}