package Klava;

import java.awt.*;

public class NetFrame extends ClosableFrame
{
  List node_list = new List();
  TextArea connections_text = new TextArea();


  public NetFrame(String title)
  {
    super(title);
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    this.add(node_list, BorderLayout.WEST);
    this.add(connections_text, BorderLayout.CENTER);
  }

  protected void close_this_window()
  {
    super.close_this_window();
    System.exit(0);
  }

  void print(String s)
  {
    connections_text.append(s);
  }

  void printNewNode(Locality l)
  {
    node_list.add(l.toString());
  }

  void printRemovedNode(Locality l)
  {
    synchronized( node_list ) {
      for( int i = 0 ; i < node_list.getItemCount() ; i++ ) {
	      if ( node_list.getItem( i ).equals( l.toString() ) ) {
	        node_list.remove( i ) ;
	        break ;
	      }
      }
    }
  }
}

 