package Klava;

public interface NetNodeInterface extends NodeInterface {
  void accept(PhysicalLocality loc);
  boolean register(PhysicalLocality ploc, LogicalLocality lloc);
  void unregister(LogicalLocality loc);

  boolean login(Locality loc) throws KlavaException;
  boolean subscribe(PhysicalLocality ploc, LogicalLocality lloc)
     throws KlavaException;

  void logout(Locality loc);
  void unsubscribe(Locality loc, LogicalLocality myloc) throws KlavaException;

  void disconnected(PhysicalLocality loc);
  void disconnected(PhysicalLocality loc, LogicalLocality lloc);

  void bindloc(LogicalLocality ll, PhysicalLocality pl) throws KlavaException;
  void unbindloc(LogicalLocality ll) throws KlavaException;

  void acceptconn(PhysicalLocality loc);
  boolean dirconnect(Locality loc) throws KlavaException;
}