
//Title:        Your Product Name
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Your Name
//Company:      Your Company
//Description:  Your description

package Klava;

import java.awt.*;

public class NodePanel extends Panel implements withPanel, withNodeMonitors {
  GridLayout MainLayout = new GridLayout();
  Panel TSPanel = new Panel();
  Panel MessagePanel = new Panel();
  Panel ProcPanel = new Panel() ;
  Panel EnvPanel = new Panel() ;
  Panel ProcEnvTSPanel = new Panel();
  KlavaMonitorPanel MessageArea =
    new KlavaMonitorPanel( "Messages", new KlavaMonitorTextAreaPanel() );
  KlavaMonitorPanel ProcList =
    new KlavaMonitorPanel( "Processes", new KlavaMonitorListPanel() );
  KlavaMonitorPanel EnvList =
    new KlavaMonitorPanel( "Environment", new KlavaMonitorListPanel() );
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  GridLayout gridLayout2 = new GridLayout();


  public NodePanel() {
    try  {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public void addTSPanel( Component TSList ) { TSPanel.add( TSList ) ; }

    // withPanel interface
    public Panel getPanel() { return this ; }
    
    // withNodePanel interface
    public KlavaMonitor getMessageMonitor() { return MessageArea ; }
    public KlavaMonitor getProcMonitor() { return ProcList ; }
    public KlavaMonitor getEnvMonitor() { return EnvList ;  }  

  void jbInit() throws Exception {
    MainLayout.setRows(2);
    borderLayout2.setVgap(2);
    borderLayout3.setVgap(2);
    borderLayout4.setVgap(2);
    TSPanel.setLayout(borderLayout4);
    MessagePanel.setLayout(borderLayout1);
    ProcEnvTSPanel.setLayout(gridLayout2);
    ProcPanel.setLayout(borderLayout2);
    gridLayout2.setHgap(2);
    gridLayout2.setColumns(3);
    gridLayout2.setVgap(2);
    EnvPanel.setLayout(borderLayout3);
    this.setLayout(MainLayout);
    MessagePanel.add(MessageArea, BorderLayout.CENTER);
    this.add(ProcEnvTSPanel, null);
    ProcEnvTSPanel.add(ProcPanel, null);
    ProcPanel.add(ProcList, BorderLayout.CENTER);
    ProcEnvTSPanel.add(EnvPanel, null);
    EnvPanel.add(EnvList, BorderLayout.CENTER);
    ProcEnvTSPanel.add(TSPanel, null);
    this.add(MessagePanel, null);
  }

  synchronized public void addRow( Component c ) {
    MainLayout.setRows( MainLayout.getRows() + 1 ) ;
    add( c ) ;
  }


  synchronized public void addMessage( String s ) {
    MessageArea.addElem( s ) ;
  }
}


