package Klava ;

import java.awt.* ;
import java.io.* ;
import org.mikado.imc.mobility.NodeClassLoader;

public class NodeScreen extends Node implements withPanel {

  protected boolean visible = true ;
  protected Panel textAreaPanel ;

  public NodeScreen( String Name, String Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
  }

  public NodeScreen( String Name, String Here, String NetHostName, Integer NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort ) ;
  }

  public NodeScreen( String Name, PhysicalLocality Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
  }

  protected TupleSpace newTupleSpace() {
    TupleSpaceScreen TSS = new TupleSpaceScreen( name ) ;
    textAreaPanel = TSS.getPanel() ;
    return TSS ;
  }

  // factory method
  protected Environment newEnvironment( String name )
  {
      try {
          return new Environment ();
          // we don't read any file
      } catch (KlavaMalformedPhyLocalityException mfl) {
          mfl.printStackTrace();
          return null;
      }
  }

  // factory method
  protected NodeClassLoader newNodeClassLoader()
  {
    //return new NodeClassLoader ();
    return null ; // due to Security
  }

  public void setVisible( boolean vis ) { visible = vis ; }

  // withPanel interface
  public Panel getPanel() { return textAreaPanel ; }

  protected void show() {
    if ( visible )
      TS.show()  ;
  }

  // no processes allowed in a screen node
  protected void handleRemoteProcess( KlavaProcessPacket pack ) {
    System.err.println( "Remote Process not allowed: " + pack ) ;
  }

  public static void main( String args[] ) throws IOException, KlavaException {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeScreen n = new NodeScreen( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;
    n.start() ;
  }
}
