package Klava ;

public class PhysicalLocality extends Locality {

  public PhysicalLocality() { super() ; }

  public PhysicalLocality( String l ) throws KlavaMalformedPhyLocalityException {
    super( l ) ;

    // check correctness
    int ind = l.indexOf(':');
    if (ind <= 0 || ind != l.lastIndexOf(':'))
      throw new KlavaMalformedPhyLocalityException(l);
  }

  public PhysicalLocality( PhysicalLocality l ) {
    super( l ) ;
  }

  public PhysicalLocality( Locality l ) { super(l); }

  public PhysicalLocality(KString s) { super(s); }

  public Object getLocality() {
    return locality ;
  }
  public Object duplicate() {
    return new PhysicalLocality (this) ;
  }

  public String toString() {
    if ( locality != null )
      return ( String ) locality ;
    else
      return "!PhysicalLocality" ;
  }
}
