
//Title:        Your Product Name
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Your Name
//Company:      Your Company
//Description:  Your description

package Klava;

import java.awt.*;
import java.awt.event.*;

public class TSKeybPanel extends Panel {
  TextField textField = new TextField();
  Panel panel1 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();

  protected TupleSpace TS ;
  FlowLayout flowLayout1 = new FlowLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  Label label1 = new Label();

  public TSKeybPanel( TupleSpace ts ) {
    TS = ts ;
    try  {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setSize(new Dimension(398, 90));
    textField.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        textField_keyPressed(e);
      }
    });
    buttonOK.setLabel("OK");
    buttonOK.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonOK_mouseClicked(e);
      }
    });
    buttonCancel.setLabel("Cancel");
    label1.setText("keyboard");
    buttonCancel.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonCancel_mouseClicked(e);
      }
    });
    panel1.setLayout(flowLayout1);
    this.setLayout(borderLayout1);
    this.add(textField, BorderLayout.CENTER);
    this.add(panel1, BorderLayout.SOUTH);
    panel1.add(buttonOK, null);
    panel1.add(buttonCancel, null);
    this.add(label1, BorderLayout.NORTH);
  }

  protected void parseText( String s ) {
    //TS.out( new Tuple( new KString( s ) ) ) ;
    try {
      TS.outString( s ) ;
      System.out.println( "TS : " + TS ) ;
    } catch ( KlavaTupleParsingException e ) {
      System.err.println( e ) ;
    }
  }

  void buttonOK_mouseClicked(MouseEvent e) {
    parseText( textField.getText() ) ;
  }

  void buttonCancel_mouseClicked(MouseEvent e) {
    clearText() ;
  }

  void clearText() { textField.setText( "" ) ; }

  void textField_keyPressed(KeyEvent e) {
    switch ( e.getKeyCode() ) {
      case KeyEvent.VK_ENTER :
        parseText( textField.getText() ) ;
        break ;
      case KeyEvent.VK_ESCAPE :
        clearText() ;
        break ;
    }
  }
}

          
