package Klava ;

import java.awt.Frame ;
import java.awt.List ;
import java.awt.Component ;
import java.awt.Panel ;

public class TupleSpaceG extends TupleSpace implements java.io.Serializable, withPanel {

  protected Frame TSframe = null ;
  protected List TupleList ;

  protected KlavaMonitorPanel tsMonitorPanel ;

  public TupleSpaceG() {
    this( new KlavaMonitorPanel( "TS" ) ) ;
  }

  public TupleSpaceG( KlavaMonitorPanel p ) {
    tsMonitorPanel = p ;
    tsMonitorPanel.setMonitor( new KlavaMonitorListPanel() ) ;
    addMonitor (tsMonitorPanel);
  }

  // withPanel interface
  public Panel getPanel() { return tsMonitorPanel ; }

  public Component getTupleList() {
    return TupleList ;
  }
}
