package Klava.crypto;

/**
 * Common interface to request a key to the user or to some one else.
 *
 * @author $author$
 * @version $Revision: 1.1.2.2 $
 */
public interface KStoreAccess {
    /**
     * Request a key alias and a password
     *
     * @param message the message to request the key
     * @param store the KStore that requests the key
     *
     * @return the KeyInfo with the requested information
     *
     * @throws IOException
     * @throws java.security.GeneralSecurityException
     */
    public KeyInfo askKey(String message, KStore store)
        throws java.io.IOException, java.security.GeneralSecurityException;
}
