package Klava.debug;

import Klava.PhysicalLocality;

public class LocalityCondition implements Breakpoint.Condition {

  protected PhysicalLocality requiredLocality ;

  public LocalityCondition( PhysicalLocality requiredLocality ) {
    this.requiredLocality = requiredLocality ;
  }

  public boolean isSatisfiedBy( KlavaAgent a ) {
    return a.getLocality().equals( requiredLocality ) ;
  }

}