package Klava.debug;

public class LocationCondition implements Breakpoint.Condition {

  protected Location requiredLocation ;

  public LocationCondition( Location requiredLocation ) {
    this.requiredLocation = requiredLocation ;
  }

  public LocationCondition( String procName, int line, int col ) {
    this( new Location( procName, line, col ) ) ;
  }

  public boolean isSatisfiedBy( KlavaAgent a ) throws DebugException {
    return a.getCurrentProcess().getLocation().equals( requiredLocation ) ;
  }

}