
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description


package klavatest;

import Klava.*;
import java.io.* ;

public class testNodeG extends KlavaProcess {

  public testNodeG() {
  }

  public void execute() throws KlavaException {
    try {
      Thread.sleep( 3000 ) ;
    } catch ( InterruptedException e ) {}
    KString s = new KString() ;
    out( new KInteger(10), new KInteger(20), self ) ;
    out( new KInteger(10), new KBoolean(false), self ) ;
    out( new KBoolean(true), self ) ;
    out( new KString("hi"), self ) ;
    in( s, self ) ;
    in(new KBoolean(), self);
    System.out.println( "DONE ! :-)" ) ;
  }

  public static void main( String args[] ) throws Exception {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeG n = new NodeG( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;

    int port = NetUtils.retrieveConnectionPortFromLocality(args[1]);

    n.addToEnv( "loc1", port + 1 ) ;
    n.addToEnv( "loc2", port + 2 ) ;
    n.start() ;
    n.addProcess( new testNodeG() ) ;
  }
}