package mikadotest.mobility;

/**
 * <p>Title: Mikado Mobility package</p>
 * <p>Description: provide classes for moving code to another site</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Dip. Sistemi e Informatica, Univ. Firenze</p>
 * @author Lorenzo Bettini, bettini at dsi.unifi.it
 * @version 1.0
 */

public class BarClass implements java.io.Serializable {
  boolean do_exc = false;

  public BarClass() {
  }

  public String bar(BarPar p) throws BarException {
    if (do_exc)
      throw new BarException("BAR");

    return "BarClass.bar - " + p.bars();
  }
}

class BarPar implements java.io.Serializable {
  String bars() {
    return "BarParString";
  }
}

class BarException extends Exception {
  public BarException(String s) {
    super(s);
  }
}