package org.mikado.imc.mobility;

import java.io.IOException;


/**
 * An implementation of MigratingCodeMarshaller suitable for Java byte code
 * class loading, starting from a JavaMigratingCode and returning a JavaMigratingPacket.
 *
 * @author Lorenzo Bettini
 * @version $Revision: 1.1 $
 */
public class JavaByteCodeMarshaller implements MigratingCodeMarshaller {

	/* (non-Javadoc)
	 * @see org.mikado.imc.mobility.MigratingCodeMarshaller#marshal(org.mikado.imc.mobility.MigratingCode)
	 */
	public MigratingPacket marshal(MigratingCode code) throws IOException {
		return ((JavaMigratingCode)code).make_packet();
	}     
}
