import java.io.*;
import javax.crypto.*;
import javax.crypto.spec.*;

class GenCipher {

    public static void main(String[] args) {

      
 /* Verify a DSA signature */

        if (args.length != 1) {
            System.out.println("Usage: GenCipher keyfile");
            }
        else try{

            /* import encoded key */

            FileInputStream keyfis = new FileInputStream(args[0]);
            byte[] encKey = new byte[keyfis.available()];  
            keyfis.read(encKey);

            keyfis.close();
	    
	    DESKeySpec desKeySpec = new DESKeySpec(encKey);

            SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES", "SunJCE");
            SecretKey desKey = keyFactory.generateSecret(desKeySpec);


  /* Create a Chiper object and initialize it with the private key */
	    
	    Cipher desCipher = Cipher.getInstance("DES", "SunJCE");
	    desCipher.init(Cipher.ENCRYPT_MODE, desKey);


   /* Crypt the clear text */

	    byte[] cleartext = "This is just an example".getBytes();
	    byte[] ciphertext = desCipher.doFinal(cleartext);

      
   /* Save the cipher text in a file */
            FileOutputStream ciphfos = new FileOutputStream("cipher");
            ciphfos.write(ciphertext);

            ciphfos.close();
   

        } catch (Exception e) {
            System.err.println("Caught exception " + e.toString());
        }

    };

}


