import java.io.*;
import javax.crypto.*;

class GenKey {

    public static void main(String[] args) {

        /* Generate a DSA signature */

        if (args.length != 0) {
            System.out.println("Usage: GenKeyPair");
            }
        else try{

            /* Generate a key  */

            KeyGenerator keygen = KeyGenerator.getInstance("DES", "SunJCE");
         
	    SecretKey desKey = keygen.generateKey();

            /* Save the public key in a file */
            byte[] key = desKey.getEncoded();
            FileOutputStream keyfos = new FileOutputStream("deskey");
            keyfos.write(key);

            keyfos.close();

 
        } catch (Exception e) {
            System.err.println("Caught exception " + e.toString());
        }

    };

}


