/**
 * LocalInFailure
 *
 * retrieves a tuple crypted with a different key, using an in
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class TrystoreProc1 extends KlavaProcessx {

    public TrystoreProc1() throws Exception {
	super (new KStoreFileAccess("Trystore1.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
	    setEncKey("1");
            
            Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("lorenzo1")) ;
            KString s = new KString("usata chiave1") ;
            tx1.add(new KCipher(s)) ;
	    tx1.encode();
            out(tx1,self) ;
	    
	} catch (Exception e1) {
            e1.printStackTrace ();
        }
    }
}

class TrystoreProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("self");

    public TrystoreProc2() throws Exception {
	super (new KStoreFileAccess("Trystore2.answers"));
	//super (new KStoreDialogAccess());
    }
    
    public void execute() throws KlavaException {
        try {
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
            KCipher k = new KCipher( fString1 ) ;
            txf1.add( k ) ;
	    
	    read(txf1, dati) ;
                       
	    out(s1,self);
            out(fString1,self);
	} catch (Exception e) {
            e.printStackTrace ();
        }
    }
}

public class Trystore {
    static public void main  (String args[]) throws Exception {
        Node Node1 = new NodeG ("node1", "loc1", "localhost", 9999 );
        Node1.setLocalMatcher (new KCipherLocalMatcher ());
        Node1.setLocalTupleSpaceMatcher
            (new KCipherLocalTupleSpaceMatcher ());
	Node1.start();
	Node1.addProcess (new TrystoreProc1());
	Node1.addProcess (new TrystoreProc2());
    }
}
